Index: doc/bsp_howto/nvmem.t
===================================================================
--- doc/bsp_howto/nvmem.t	(revision 06fee20ac167d70ff13aa14760ecdc2ff6d7b6a7)
+++ doc/bsp_howto/nvmem.t	(revision bc950e878a06243e272493eff8a9509b4e416483)
@@ -9,4 +9,227 @@
 @chapter Non-Volatile Memory Driver
 
-XXX FILL ME IN
-
+The Non-Volatile driver is responsible for providing an
+interface to various types of non-volatile memory.  These
+types of memory include, but are not limited to, Flash, EEPROM,
+and battery backed RAM.  The capabilities provided
+by this class of device driver are:
+
+@itemize @bullet
+@item Initialize the Non-Volatile Memory Driver
+@item Optional Disable Read and Write Handlers
+@item Open a Particular Memory Partition
+@item Close a Particular Memory Partition
+@item Read from a Particular Memory Partition
+@item Write to a Particular Memory Partition
+@item Erase the Non-Volatile Memory Area
+@end itemize
+
+There is currently only one non-volatile device driver included in the
+RTEMS source tree and it does not adhere to this device driver model.  
+The information provided in this chapter is based on drivers developed
+by OAR Corporation personnel for applications using RTEMS.   It is
+hoped that this driver model information can form the basis for a standard
+non-volatile memory driver model that can be supported in future RTEMS
+distribution.
+
+@section Major and Minor Numbers
+
+The @b{major} number of a device driver is its index in the
+RTEMS Device Address Table.
+
+A @b{minor} number is associated with each device instance
+managed by a particular device driver.  An RTEMS minor number
+is an @code{unsigned32} entity.  Convention calls
+dividing the bits in the minor number down into categories
+that specify an area of non-volatile memory and a partition
+with that area.  This results in categories
+like the following:
+
+@itemize @bullet
+
+@item @b{area} - indicates a block of non-volatile memory
+@item @b{partition} - indicates a particular address range with an area
+
+@end itemize
+
+From the above, it should be clear that a single device driver
+can support multiple types of non-volatile memory in a single system.
+The minor number is used to distinguish the types of memory and
+blocks of memory used for different purposes.
+
+@section Non-Volatile Memory Driver Configuration
+
+There is not a standard non-volatile driver configuration table but some
+fields are common across different drivers.  The non-volatile memory driver
+configuration table is typically an array of structures with each
+structure containing the information for a particular area of
+non-volatile memory.
+The following is a list of the type of information normally required
+to configure each area of non-volatile memory
+
+@table @b
+@item memory_type
+is the type of memory device in this area.  Choices are battery backed RAM,
+EEPROM, Flash, or an optional user-supplied type.  If the user-supplied type
+is configured, then the user is responsible for providing a set of
+routines to program the memory.
+
+@item memory
+is the base address of this memory area.
+
+@item attributes
+is a pointer to a memory type specific attribute block.  Some of
+the fields commonly contained in this memory type specific attribute
+structure area:
+
+@table @b
+@item use_protection_algorithm
+is set to TRUE to indicate that the protection (i.e. locking) algorithm
+should be used for this area of non-volatile memory.  A particular
+type of non-volatile memory may not have a protection algorithm.
+
+@item access
+is an enumerated type to indicate the organization of the memory 
+devices in this memory area.  The following is a list of the
+access types supported by the current driver implementation:
+
+@itemize @bullet
+@item simple unsigned8
+@item simple unsigned16 
+@item simple unsigned32 
+@item simple unsigned64
+@item single unsigned8 at offset 0 in an unsigned16
+@item single unsigned8 at offset 1 in an unsigned16 
+@item single unsigned8 at offset 0 in an unsigned32
+@item single unsigned8 at offset 1 in an unsigned32 
+@item single unsigned8 at offset 2 in an unsigned32 
+@item single unsigned8 at offset 3 in an unsigned32 
+@end itemize
+
+@item depth
+is the depth of the progamming FIFO on this particular chip.  Some 
+chips, particularly EEPROMs, have the same programming algorithm but
+vary in the depth of the amount of data that can be programmed in a single
+block.
+
+@end table
+
+@item number_of_partitions
+is the number of logical partitions within this area.
+
+@item Partitions
+is the address of table that contains an entry to describe each
+partition in this area.  Fields within each element of this
+table are defined as follows:
+
+@table @b
+
+@item offset
+is the offset of this partition from the base address of this area.
+
+@item length 
+is the length of this partition.
+
+@end table
+@end table
+
+By dividing an area of memory into multiple partitions, it is possible 
+to easily divide the non-volatile memory for different purposes.
+
+@section Initialize the Non-Volatile Memory Driver
+
+At system initialization, the non-volatile memory driver's
+initialization entry point will be invoked.  As part of
+initialization, the driver will perform
+whatever initializatin is required on each non-volatile memory area.
+
+The discrete I/O driver may register devices name for memory 
+partitions of particular interest to the system.  Normally this
+will be restricted to the device "/dev/nv_memory" to indicate
+the entire device driver.
+
+@section Disable Read and Write Handlers
+
+Depending on the target's non-volatile memory configuration, it may be
+possible to write to a status register and make the memory area completely 
+inaccessible.  This is target dependent and beyond the standard capabilities
+of any memory type.  The user has the optional capability to provide 
+handlers to disable and enable access to a partiticular memory area.
+
+@section Open a Particular Memory Partition
+
+This is the driver open call.  Usually this call does nothing other than
+validate the minor number.
+
+With some drivers, it may be necessary to allocate memory when a particular
+device is opened.  If that is the case, then this is often the place
+to do this operation.
+
+@section Close a Particular Memory Partition
+
+This is the driver close call.  Usually this call does nothing.
+
+With some drivers, it may be necessary to allocate memory when a particular
+device is opened.  If that is the case, then this is the place
+where that memory should be deallocated.
+
+@section Read from a Particular Memory Partition
+
+This corresponds to the driver read call.  After validating the minor
+number and arguments, this call enables reads from the specified
+memory area by invoking the user supplied "enable reads handler"
+and then reads the indicated memory area.  When
+invoked the @code{argument_block} is actually a pointer to the following
+structure type:
+
+@example
+@group
+typedef struct @{
+  rtems_unsigned32   offset;
+  void              *buffer;
+  rtems_unsigned32   length;
+  rtems_unsigned32   status;
+@}   Non_volatile_memory_Driver_arguments;
+@end group
+@end example
+
+The driver reads @code{length} bytes starting at @code{offset} into
+the partition and places them at @code{buffer}.  The result is returned 
+in @code{status}.
+
+After the read operation is complete, the user supplied "disable reads handler"
+is invoked to protect the memory area again.
+
+@section Write to a Particular Memory Partition
+
+This corresponds to the driver write call.   After validating the minor
+number and arguments, this call enables writes to the specified
+memory area by invoking the "enable writes handler", then unprotecting
+the memory area, and finally actually writing to the indicated memory
+area.  When invoked the @code{argument_block} is actually a pointer to
+the following structure type:
+
+@example
+@group
+typedef struct @{
+  rtems_unsigned32   offset;
+  void              *buffer;
+  rtems_unsigned32   length;
+  rtems_unsigned32   status;
+@}   Non_volatile_memory_Driver_arguments;
+@end group
+@end example
+
+The driver writes @code{length} bytes from @code{buffer} and 
+writes them to the non-volatile memory starting at @code{offset} into
+the partition.  The result is returned in @code{status}.
+
+After the write operation is complete, the "disable writes handler"
+is invoked to protect the memory area again.
+
+@section Erase the Non-Volatile Memory Area
+
+This is one of the IOCTL functions supported by the I/O control
+device driver entry point.  When this IOCTL function is invoked,
+the specified area of non-volatile memory is erased.
+
Index: doc/bsp_howto/rtc.t
===================================================================
--- doc/bsp_howto/rtc.t	(revision 06fee20ac167d70ff13aa14760ecdc2ff6d7b6a7)
+++ doc/bsp_howto/rtc.t	(revision bc950e878a06243e272493eff8a9509b4e416483)
@@ -9,4 +9,179 @@
 @chapter Real-Time Clock Driver
 
-XXX FILL ME IN
+@section Introduction
 
+The Real-Time Clock (@b{RTC}) driver is responsible for providing an
+interface to an @b{RTC} device.  [NOTE: In this chapter, the abbreviation
+@b{TOD} is used for @b{Time of Day}.]  The capabilities provided by this
+driver are:
+
+@itemize @bullet
+@item Set the RTC TOD to RTEMS TOD
+@item Set the RTEMS TOD to the RTC TOD
+@item Get the RTC TOD
+@item Set the RTC TOD to the Specified TOD
+@item Get the Difference Between the RTEMS and RTC TOD
+@end itemize
+
+The reference implementation for a real-time clock driver can 
+be found in @code{c/src/lib/libbsp/shared/tod.c}.  This driver
+is based on the libchip concept and can be easily configured 
+to work with any of the RTC chips supported by the RTC
+chip drivers in the directory @code{c/src/lib/lib/libchip/rtc}.
+There is a README file in this directory for each supported
+RTC chip.  Each of these README explains how to configure the
+shared libchip implementation of the RTC driver for that particular
+RTC chip.
+
+The DY-4 DMV177 BSP uses the shared libchip implementation of the RTC
+driver.  Its @code{RTC_Table} configuration table can be found in
+@code{c/src/lib/libbsp/powerpc/dmv177/tod/config.c}.
+
+@section Initialization
+
+The @code{rtc_initialize} routine is responsible for initializing the
+RTC chip so it can be used.  The shared libchip implementation of this
+driver supports multiple RTCs and bases its initialization order on
+the order the chips are defined in the @code{RTC_Table}.  Each chip
+defined in the table may or may not be present on this particular board.
+It is the responsibility of the @code{deviceProbe} to indicate the
+presence of a particular RTC chip.  The first RTC found to be present
+is considered the preferred RTC.
+
+In the shared libchip based implementation
+of the driver, the following actions are performed:
+
+@example
+@group
+rtems_device_driver rtc_initialize(
+  rtems_device_major_number  major,
+  rtems_device_minor_number  minor_arg,
+  void                      *arg
+)
+@{
+   for each RTC configured in RTC_Table
+     if the deviceProbe for this RTC indicates it is present
+       set RTC_Minor to this device
+       set RTC_Present to TRUE
+       break out of this loop
+
+   if RTC_Present is not TRUE
+     return RTEMS_INVALID_NUMBER to indicate that no RTC is present
+
+   register this minor number as the "/dev/rtc"
+
+   perform the deviceInitialize routine for the preferred RTC chip
+
+   for RTCs past this one in the RTC_Table
+     if the deviceProbe for this RTC indicates it is present
+       perform the deviceInitialize routine for this RTC chip
+       register the configured name for this RTC
+@}
+@end group
+@end example
+
+The @code{deviceProbe} routine returns TRUE if the device
+configured by this entry in the @code{RTC_Table} is present.  
+This configuration scheme allows one to support multiple versions
+of the same board with a single BSP.  For example, if the first
+generation of a board had Vendor A's RTC chip and the second
+generation had Vendor B's RTC chip, RTC_Table could contain 
+information for both.  The @code{deviceProbe} configured
+for Vendor A's RTC chip would need to return TRUE if the
+board was a first generation one.  The @code{deviceProbe}
+routines are very board dependent.
+
+@section setRealTimeToRTEMS
+
+The @code{setRealTimeToRTEMS} routine sets the current RTEMS TOD to that
+of the preferred RTC.  
+
+@example
+@group
+void setRealTimeToRTEMS(void)
+@{
+  if no RTCs are present
+    return
+
+  invoke the deviceGetTime routine for the preferred RTC
+  set the RTEMS TOD using rtems_clock_set
+@}
+@end group
+@end example
+
+@section setRealTimeFromRTEMS
+
+The @code{setRealTimeFromRTEMS} routine sets the preferred RTC TOD to the
+current RTEMS TOD.
+
+@example
+@group
+void setRealTimeFromRTEMS(void)
+@{
+  if no RTCs are present
+    return
+
+  obtain the RTEMS TOD using rtems_clock_get
+  invoke the deviceSetTime routine for the preferred RTC
+@}
+@end group
+@end example
+
+@section getRealTime
+
+The @code{getRealTime} returns the preferred RTC TOD to the
+caller.
+
+@example
+@group
+void getRealTime( rtems_time_of_day *tod )
+@{
+  if no RTCs are present
+    return
+
+  invoke the deviceGetTime routine for the preferred RTC
+@}
+@end group
+@end example
+
+@section setRealTime
+
+The @code{setRealTime} routine sets the preferred RTC TOD to the
+TOD specified by the caller.
+
+@example
+@group
+void setRealTime( rtems_time_of_day *tod )
+@{
+  if no RTCs are present
+    return
+
+  invoke the deviceSetTime routine for the preferred RTC
+@}
+@end group
+@end example
+
+@section checkRealTime
+
+The @code{checkRealTime} routine returns the number of seconds
+difference between the RTC TOD and the current RTEMS TOD.
+
+@example
+@group
+int checkRealTime( void )
+@{
+  if no RTCs are present
+    return -1
+
+  
+  obtain the RTEMS TOD using rtems_clock_get
+  get the TOD from the preferred RTC using the deviceGetTime routine
+
+  convert the RTEMS TOD to seconds
+  convert the RTC TOD to seconds
+ 
+  return the RTEMS TOD in seconds - RTC TOD in seconds
+@}
+@end group
+@end example
+
Index: doc/bsp_howto/shmsupp.t
===================================================================
--- doc/bsp_howto/shmsupp.t	(revision 06fee20ac167d70ff13aa14760ecdc2ff6d7b6a7)
+++ doc/bsp_howto/shmsupp.t	(revision bc950e878a06243e272493eff8a9509b4e416483)
@@ -9,4 +9,261 @@
 @chapter Shared Memory Support Driver
 
-XXX FILL ME IN
-
+The Shared Memory Support Driver is responsible for providing glue
+routines and configuration information required by the Shared 
+Memory Multiprocessor Communications Interface (MPCI).  The
+Shared Memory Support Driver tailors the portable Shared
+Memory Driver to a particular target platform.
+
+This driver is only required in shared memory multiprocessing
+systems that use the RTEMS mulitprocessing support.  For more
+information on RTEMS multiprocessing capabilities and the
+MPCI, refer to the @b{Multiprocessing Manager} chapter
+of the @b{RTEMS Application C User's Guide}.
+
+@section Shared Memory Configuration Table 
+
+The Shared Memory Configuration Table is defined in the following 
+structure:
+
+@example
+@group
+typedef volatile rtems_unsigned32 vol_u32;
+
+typedef struct @{
+  vol_u32 *address;        /* write here for interrupt    */
+  vol_u32  value;          /* this value causes interrupt */
+  vol_u32  length;         /* for this length (0,1,2,4)   */
+@} Shm_Interrupt_information;
+
+struct shm_config_info @{
+  vol_u32           *base;       /* base address of SHM         */
+  vol_u32            length;     /* length (in bytes) of SHM    */
+  vol_u32            format;     /* SHM is big or little endian */
+  vol_u32          (*convert)(); /* neutral conversion routine */
+  vol_u32            poll_intr; /* POLLED or INTR driven mode  */
+  void             (*cause_intr)( rtems_unsigned32 );
+  Shm_Interrupt_information   Intr;     /* cause intr information      */
+@};
+
+typedef struct shm_config_info shm_config_table;
+@end group
+@end example
+
+where the fields are defined as follows:
+
+@table @b
+@item base
+is the base address of the shared memory buffer used to pass
+messages between the nodes in the system.
+
+@item length
+is the length (in bytes) of the shared memory buffer used to pass
+messages between the nodes in the system.
+
+@item format
+is either SHM_BIG or SHM_LITTLE to indicate that the neutral format
+of the shared memory area is big or little endian.  The format 
+of the memory should be chosen to match most of the inter-node traffic.
+
+@item convert
+is the address of a routine which converts from native format to
+neutral format.   Ideally, the neutral format is the same as the
+native format so this routine is quite simple.
+
+@item poll_intr
+is either INTR_MODE or POLLED_MODE to indicate how the node will be
+informed of incoming messages.
+
+@item cause_intr
+
+@item Intr
+is the information required to cause an interrupt on a node.  This
+structure contains the following fields:
+@table @b
+@item address
+is the address to write at to cause an interrupt on that node.
+For a polled node, this should be NULL.
+
+@item value
+is the value to write to cause an interrupt.
+
+@item length
+is the length of the entity to write on the node to cause an interrupt.
+This can be 0 to indicate polled operation, 1 to write a byte, 2 to
+write a sixteen-bit entity, and 4 to write a thirty-two bit entity.
+@end table
+@end table
+
+@section Primitives
+
+@subsection Convert Address
+
+The @code{Shm_Convert_address} is responsible for converting an address
+of an entity in the shared memory area into the address that should be
+used from this node.  Most targets will simply return the address
+passed to this routine.  However, some target boards will have a special
+window onto the shared memory.  For example, some VMEbus boards have
+special address windows to access addresses that are normally reserved
+in the CPU's address space. 
+
+@example
+@group
+void *Shm_Convert_address( void *address )
+@{
+   return the local address version of this bus address
+@}
+@end group
+@end example
+
+@subsection Get Configuration
+
+The @code{Shm_Get_configuration} routine is responsible for filling in the
+Shared Memory Configuration Table passed to it.  
+
+@example
+@group
+void Shm_Get_configuration(
+  rtems_unsigned32   localnode,
+  shm_config_table **shmcfg
+)
+@{
+   fill in the Shared Memory Configuration Table 
+@}
+@end group
+@end example
+
+@subsection Locking Primitives
+
+This is a collection of routines that are invoked by the portable
+part of the Shared Memory Driver to manage locks in the shared
+memory buffer area.  Accesses to the shared memory must be 
+atomic.  Two nodes in a multiprocessor system must not be manipulating
+the shared data structures simultaneously.  The locking primitives
+are used to insure this.  
+
+To avoid deadlock, local processor interrupts should be disabled the entire
+time the locked queue is locked.
+
+The locking primitives operate on the lock
+@code{field} of the @code{Shm_Locked_queue_Control}
+data structure.  This structure is defined as follows:
+
+@example
+@group
+typedef struct @{
+  vol_u32 lock;  /* lock field for this queue    */
+  vol_u32 front; /* first envelope on queue      */
+  vol_u32 rear;  /* last envelope on queue       */
+  vol_u32 owner; /* receiving (i.e. owning) node */
+@} Shm_Locked_queue_Control;
+@end group
+@end example
+
+where each field is defined as follows:
+
+@table @b
+@item lock
+is the lock field.  Every node in the system must agree on how this
+field will be used.  Many processor families provide an atomic
+"test and set" instruction that is used to manage this field.
+
+@item front
+is the index of the first message on this locked queue.
+
+@item rear
+is the index of the last message on this locked queue.
+
+@item owner
+is the node number of the node that currently has this structure locked.
+
+@end table
+
+@subsubsection Initializing a Shared Lock
+
+The @code{Shm_Initialize_lock} routine is responsible for 
+initializing the lock field.  This routines usually is implemented
+as follows:
+
+@example
+@group
+void Shm_Initialize_lock(
+  Shm_Locked_queue_Control *lq_cb
+)
+@{
+  lq_cb->lock = LQ_UNLOCKED;
+@} 
+@end group
+@end example
+
+@subsubsection Acquiring a Shared Lock
+
+The @code{Shm_Lock} routine is responsible for
+acquiring the lock field.  Interrupts should be
+disabled while that lock is acquired.  If the lock
+is currently unavailble, then the locking routine
+should delay a few microseconds to allow the other
+node to release the lock.  Doing this reduces bus contention
+for the lock.  This routines usually is implemented as follows:
+
+@example
+@group
+void Shm_Lock(
+  Shm_Locked_queue_Control *lq_cb
+)
+@{
+  disable processor interrupts
+    set Shm_isrstat to previous interrupt disable level
+    
+    while ( TRUE ) @{
+      atomically attempt to acquire the lock
+      if the lock was acquired
+        return
+      delay some small period of time
+    @}
+@}
+@end group
+@end example
+
+@subsubsection Releasing a Shared Lock
+
+The @code{Shm_Unlock} routine is responsible for
+releasing the lock field and reenabling processor
+interrupts.  This routines usually is implemented as follows:
+
+@example
+@group
+void Shm_Unlock(
+  Shm_Locked_queue_Control *lq_cb 
+)
+@{
+  set the lock to the unlocked value
+  reenable processor interrupts to their level prior
+    to the lock being acquired.  This value was saved
+    in the global variable Shm_isrstat
+@}
+@end group
+@end example
+
+@section Installing the MPCI ISR
+
+The @code{Shm_setvec} is invoked by the portable portion
+of the shared memory to install the interrupt service routine
+that is invoked when an incoming message is announced.  Some
+target boards support an interprocessor interrupt or mailbox
+scheme and this is where the ISR for that interrupt would be
+installed.
+
+On an interrupt driven node, this routine would be implemented
+as follows:
+
+@example
+@group
+void Shm_setvec( void )
+@{
+  install the interprocessor communications ISR
+@}
+@end group
+@end example
+
+On a polled node, this routine would be empty.
+
